<?php
/* Copyright (C) 2010-2013 by Contrail Consortium. */



require_once('__init__.php');
require_module('db');
require_module('user');
require_module('service');
require_module('service/factory');

try {

	if ($_SERVER['REQUEST_METHOD'] != 'POST') {
		throw new Exception('Only calls with POST method accepted');
	}

	if (!array_key_exists('type', $_POST)){
		throw new Exception('Missing type parameter');
	}


	if (!isset($_SESSION['uid'])) {
		throw new Exception('User not logged in');
	}

	if (!isset($_SESSION['aid'])) {
		throw new Exception('Application id is not set');
	}

	$appid = $_SESSION['aid'];
	$type = $_POST['type'];

	$res = json_decode(HTTPS::post(Conf::DIRECTOR . '/add/' . $type,
	    array( 'appid' => $appid ), false, $_SESSION['uid']));

    if (!$res) {
        throw new Exception('User not logged in');
    }

    /* error creating new service */
    if (property_exists($res, 'error')) {
        throw new Exception($res->error);
    }

    $sid = $res->service->sid;

	// HACK: keep a must_reset_password flag for the MySQL service
	// we should keep this information in the service's manager state
	if ($type == 'mysql') {
		$flag = 'must_reset_passwd_for_aid'.$appid.'_sid'.$sid;
		$_SESSION[$flag] = true;
	}

	echo json_encode(array(
		'sid' => $sid,
		'create' => 1,
	));
} catch (Exception $e) {
	error_log($e->getTraceAsString());
	echo json_encode(array(
		'error' => $e->getMessage(),
	));
}
